#include "cgic.h"
#include "alexlib.h"
#define abg1 "#91C8FF"  /*I1AŦ*/
#define abg2 "#FF8080"  /*I2A*/
#define tbg "#FFFFC6"
#define Language "chinese" /*y*/

char WorkDir[MID];       /*yïҦbu@ؿ*/
char PicDir[MID];        /*ϤҦbؿ*/
char GuestFile[MID];     /*yïɮצW*/
char CGIFile[MID];       /*CGI{ɮצW*/
char HtmlPath[MID];      /*yïɮת|*/
char IndexPath[MID];     /*yï(Index)ɪ|*/
char TempPath[MID];      /*yïȦs(Tmp)ɪ|*/
char DatPath[MID];       /*yïO(Dat)ɪ|*/
char INIPath[MID];       /*yïT(INI)ɪ|*/
char AddPath[MID];       /*yïg(Add)ɪ|*/
char TempletPath[MID];   /*yïd(templet)ɪ|*/
char LogPath[MID];       /*yïO(log)|*/
char GuestURL[MID];      /*yï㪺URL*/
char webmaster[MID];     /*yï޲z̪email*/
char HomeURL[MID];       /*URL*/
char successmsg[MAX];    /*y\T*/
char NextPageMsg[MID];   /*U@r*/
char wrote[MID];         /*ggG*/
char ReplyMsg[MID];      /*^СG*/
int MsgMaxNo;            /*@̦hyƥ*/
int pageno;              /*ثe*/
int IndexNo;             /*y޽s*/
int msgno;               /*oӭyƥ*/
int allowHTML;           /*yO_iHTML*/

/*qFormo쪺ܼ*/
char WhatToDo[20];    /*ܵ{n*/
char CfgPath[MID];    /*ini ɮת|*/
char username[MAX];   /*y̦W*/
char email[MAX];      /*yEmail*/
char hpurl[MAX];      /*yhomepage*/
char ICQ[20];         /*yICQ X*/
char title[MAX];      /*yD*/
char face[20];        /*Ϯ*/
char sex[2];          /*ʧO*/
char important[10];   /*yn*/
char *content;        /*ye*/
char ReplyPage[10];   /*^yҦb*/
char ReplyNo[10];     /*^yyg*/
char AdmPage[MID];    /*޲zeɦW*/    
char Password[MID];   /*޲ẕKX*/
char Text1[MAX];      /*Od1*/
char Text2[MAX];      /*Od2*/

int CheckPassword(); /*ˬdKX*/
int WriteMsg();   /* guestadd.htm D{*/
int NewMessage(); /*gJsyD{*/
int DelMsg();     /*RyD{*/
int DisplayPage(char *Page, char *No, char *Msg); /*ܵeyAHKR*/
//int Delete(char *DelPage, char *DelNo); /*Ry*/
void ChagePage(); /*}s*/
void WriteToFile(); /*gJyïɮ*/
void WriteToIndex(int no); /*gJ*/
void output_error(char* error, int serious); /*ܿ~T*/
int read_configuration(); /*Ūiniɪ*/


/*========================================================D{*/
int cgiMain() {
	int rCfg, rWhatToDo;
	int Flag;

   /*eX^D*/
    cgiHeaderContentType("text/html");

  /*Ū ini ɩM]wҰѼ*/
    rCfg=cgiFormStringNoNewlines("CfgPath", CfgPath, sizeof(CfgPath));
	if (!read_configuration()) {
		return(1);
	}

   /*q From T*/
    rWhatToDo=cgiFormStringNoNewlines("WhatToDo", WhatToDo, sizeof(WhatToDo));

	if (strcmp(WhatToDo, "write")==0)
		Flag=WriteMsg();
	else if (( strcmp(WhatToDo, "delete")==0 ) || ( strcmp(WhatToDo, "display")==0 )) {
		Flag = CheckPassword();
		if (Flag >0 )
			return(Flag);
		Flag=DelMsg();
	}
	else if (strcmp(WhatToDo, "new")==0)
		Flag=NewMessage();
	else
		Flag=0;
	    
  

    return(Flag);
}
/*========================================================*/
int CheckPassword() {
	int rAdmPage, rPassword, Flag;
	char buf[MAX], buf1[MAX];
	FILE *fp;

	rAdmPage=cgiFormStringNoNewlines("AdmPage", AdmPage, sizeof(AdmPage));
	rPassword=cgiFormStringNoNewlines("Password", Password, sizeof(Password));
	sprintf(buf,"%s%s", WorkDir, AdmPage);

	/*}Һ޲z*/
	if ( (fp = fopen( buf, "r")) == NULL) {
      sprintf(buf,"Lk}Ҭyï޲zAz޲zyï!!");
      output_error(buf, FALSE);
      return(1);
	}

	/*ˬdKX*/
	sprintf(buf1,"<input type=\"hidden\" name=\"Password\" value=\"%s\">\n", Password);
	Flag=0;
	while( fgets(buf,MAX,fp)!=NULL ) {
		if (strcmp(buf,buf1)==0) {
			Flag =1;
			break;
		}
	}
	fclose(fp);

	if (Flag==0) {
		sprintf(buf,"KXˬdTAz޲zyï!!");
		output_error(buf, FALSE);
        return(1);
	}

	return(0);

}
/*========================================================*/
int DelMsg() {
	int rDelPage, rDelNo, Flag, i;
    char buf[MAX], buf1[MID], filename[MID], DelPage[6], *str;
	char **responses;
	FILE *fp;

	/*qŪnRMy*/
	rDelPage=cgiFormStringNoNewlines("DelPage", DelPage, sizeof(DelPage));
	rDelNo=cgiFormStringMultiple("DelNo", &responses);

	/*إ߭|*/
	if ( (strcmp(DelPage,"0")!=0) && (strcmp(DelPage,"")!=0)) {
		str = (char *) malloc(strlen(GuestFile)+1);
		strcpy(str, GuestFile);
		sprintf(buf,"%s.", DelPage);
		str = SearchReplace(str, ".", buf);
		sprintf(filename,"%s%s", WorkDir, str);
		free(str);
	}
	else
		strcpy(filename,HtmlPath);

	/*uܥXAuRy*/
	if ( strcmp(WhatToDo, "display")==0 ) {
		sprintf(buf,"");
		Flag = DisplayPage(filename,DelPage,buf);
		cgiStringArrayFree(responses);
		return Flag;
	}

	/*uܥXM~T*/
	if (rDelNo == cgiFormNotFound) {
		sprintf(buf,"SܭnRy!!");
		Flag = DisplayPage(filename,DelPage,buf);
		cgiStringArrayFree(responses);
		return Flag;
	}

	/*}ҭӧR*/
	if ( (fp = fopen( filename, "r")) == NULL) {
      sprintf(buf,"RyɡALk}ҭŪ!! S %s",filename);
      output_error(buf, TRUE);
	  cgiStringArrayFree(responses);
      return(1);
	}

	/*jMy*/
	str = NULL;
	while ( fgets(buf,MAX,fp) != NULL ) {
		i = strlen(buf);
		if ( i == strinstr(buf,"<A NAME=\"") ) {
			str = stradd(str,buf);
			continue;
		}
		/*yAP_O_Oڭ̭n*/
		i = 0;
		Flag = 0;
		while (responses[i]) {
			sprintf(buf1,"<A NAME=\"%s\"></A>\n", responses[i]);
			if ( strcmp(buf,buf1) == 0 ) {
				Flag = 1;
				break;
			}
			i++;
		}
		/*OnRy*/
		if ( Flag == 0) {
			str = stradd(str,buf);
			continue;
		}

		/*nRyAӽgy*/
		while ( fgets(buf,MAX,fp) != NULL ) {
			if ( strcmp(buf, "<!--OVER-->\n") == 0)
				break;
		}

	}

	/*Bz*/
	fclose(fp);

	/*}ҭHgJ*/
	if ( (fp = fopen( filename, "w")) == NULL) {
      sprintf(buf,"RyɡALk}ҭӼgJ!! S %s",filename);
      output_error(buf, TRUE);
	  cgiStringArrayFree(responses);
      return(1);
	}

	fputs(str,fp);
	fclose(fp);
	free(str);

	/*Rؿ*/
	if ( (fp = fopen( IndexPath, "r")) == NULL) {
      sprintf(buf,"RyɡALk}үޭŪ!! S %s",IndexPath);
      output_error(buf, TRUE);
	  cgiStringArrayFree(responses);
      return(1);
	}

	/*jMy*/
	str = NULL;
	while ( fgets(buf,MAX,fp) != NULL ) {
		i = strlen(buf);
		if ( i == strinstr(buf,"<!--") ) {
			str = stradd(str,buf);
			continue;
		}
		/*yޡAP_O_Oڭ̭n*/
		i = 0;
		Flag = 0;
		while (responses[i]) {
			sprintf(buf1,"<!--%s-->\n", responses[i]);
			if ( strcmp(buf,buf1) == 0 ) {
				Flag = 1;
				break;
			}
			i++;
		}
		/*OnRy*/
		if ( Flag == 0) {
			str = stradd(str,buf);
			continue;
		}

		/*nRyAӽgy*/
		while ( fgets(buf,MAX,fp) != NULL ) {
			if ( strcmp(buf, "</TR>\n") == 0)
				break;
		}

	}
	fclose(fp);

	/*}ҭHgJ*/
	if ( (fp = fopen( IndexPath, "w")) == NULL) {
      sprintf(buf,"RyɡALk}үޭӼgJ!! S %s",IndexPath);
	  cgiStringArrayFree(responses);
      output_error(buf, TRUE);
      return(1);
	}

	fputs(str,fp);
	fclose(fp);
	free(str);

	/*gJLog*/
	if ( (fp = fopen( LogPath, "a")) == NULL) {
      sprintf(buf,"RyɡALk}ҰO!! S %s",LogPath);
	  cgiStringArrayFree(responses);
      output_error(buf, TRUE);
      return(1);
	}

	str = NULL;
	i=0;
	while (responses[i]) {
		sprintf(buf1,"%s, ", responses[i]);
		str=stradd(str,buf1);
		i++;
	}
	fprintf(fp,"ɶ:%s\tWm:%s",PrintTime(Language), cgiRemoteAddr);
	fprintf(fp,"  RF %sgyC\n",str);
	free(str);
	fclose(fp);


	cgiStringArrayFree(responses);

	/*eXT*/
    fprintf(cgiOut, "<HTML>\n");
    fprintf(cgiOut, "<HEAD>\n");
    fprintf(cgiOut, "<TITLE>Thanks!!</TITLE>\n");
    fprintf(cgiOut, "<SCRIPT>\n<!--\nfunction LoadGuest()\n");
    fprintf(cgiOut, "  {\n    alert(\"ywgR!!\")\n");
    fprintf(cgiOut, "    self.location.href = \"%s\"\n",GuestURL);
    fprintf(cgiOut, "  }\n//-->\n</SCRIPT>\n");
    fprintf(cgiOut, "</HEAD>\n");
    fprintf(cgiOut, "<BODY BGCOLOR=#FFFFFF onLoad=\"LoadGuest()\">\n");
    fprintf(cgiOut, "</BODY>\n");
    fprintf(cgiOut, "</HTML>\n");

	return 0;

}
/*========================================================*/
int DisplayPage(char *Page, char *No, char *Msg) {
	FILE *fp;
	char buf[MAX], *str, Name[MID], Title[MAX];
	int i;

	
	/*}ҭnܪ*/
	if ( (fp = fopen( Page, "r")) == NULL) {
      sprintf(buf,"Lk}ұzQnܪ!! S %s<P>Ц^W@sJsC",Page);
      output_error(buf, FALSE);
	  
      return(1);
	}

	fprintf(cgiOut, "<html>\n");
	fprintf(cgiOut, "<head>\n");
	fprintf(cgiOut, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=big5\">\n");
	fprintf(cgiOut, "<title>Delete Message</title>\n");
	fprintf(cgiOut, "<script>\n");
	fprintf(cgiOut, "<!--\n");
	fprintf(cgiOut, "function MakeSure() {\n");
	fprintf(cgiOut, "var sFlag\n");
	fprintf(cgiOut, "sFlag = confirm('yRLk_ATwnR?')\n");
	fprintf(cgiOut, "return sFlag\n");
	fprintf(cgiOut, "}\n");
	fprintf(cgiOut, "//-->\n");
	fprintf(cgiOut, "</script>\n");
	fprintf(cgiOut, "</head>\n");
	fprintf(cgiOut, "<body bgcolor=\"#FFFFFF\">\n");
	fprintf(cgiOut, "<h1>Ry</h1>\n");
	fprintf(cgiOut, "<p>@</p>\n");
	fprintf(cgiOut, "<blockquote>\n");
	fprintf(cgiOut, "<p>nRyAЦbRye (iHh)AAUTwRC</p>\n");
	fprintf(cgiOut, "<p>YnsLAпJƵMUeXC</p>\n");
	fprintf(cgiOut, "<hr></blockquote>\n");
	fprintf(cgiOut, "<form name=\"Guest\" action=\"%s\" method=\"POST\" OnSubmit=\"return MakeSure()\">\n", CGIFile);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"CfgPath\" value=\"%s\">", INIPath);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"WhatToDo\" value=\"delete\">\n");
	fprintf(cgiOut, "<input type=\"hidden\" name=\"DelPage\" value=\"%s\">\n", No);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"AdmPage\" value=\"%s\">\n", AdmPage);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"Password\" value=\"%s\">\n", Password);
	fprintf(cgiOut, "<center>\n");
	if (strcmp(Msg,"") != 0)
		fprintf(cgiOut, "<h2><font color=\"#0080FF\">%s</font></h2>\n", Msg);
	fprintf(cgiOut, "<p><h3>ҦbG%s</h3></p>\n", Page);
	fprintf(cgiOut, "<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");
	fprintf(cgiOut, "<tr bgcolor=\"#FF0080\" align=left>\n");
	fprintf(cgiOut, "<th>&nbsp;</th><th>D</th><th>oH</th>\n");
	fprintf(cgiOut, "</tr>\n");


	/*jMy*/
	while( fgets(buf,MAX,fp) != NULL) {
		i = strlen(buf);
		if ( strinstr(buf,"<A NAME=\"") == i)
			continue;
		/*y*/
		str = (char *) malloc(i+1);
		strcpy(str,buf);
		str = SearchReplace(str, "<A NAME=\"", "");
		str = SearchReplace(str, "\"></A>\n", ""); /*oˤ@strNOӽgyޤF*/
		fprintf(cgiOut, "<tr>\n");
		fprintf(cgiOut, "<td><input type=\"checkbox\" name=\"DelNo\" value=\"%s\"></td>",str);
		free(str);
		/*DM@*/
		strcpy(Name,"");
		strcpy(Title,"");
		while( fgets(buf,MAX,fp) != NULL) {
		/*D*/
			if ( strcmp(buf,"<!--TITLE-->\n")==0 ) {
				fgets(buf,MAX,fp);
				strcpy(Title, buf);
			}
		/*@*/
			else if ( strcmp(buf,"<!--NAME-->\n")==0 ) {
				fgets(buf,MAX,fp);
				strcpy(Name, buf);
			}
			else if ( strcmp(buf,"<!--OVER-->\n")==0 )
				break;

		}
		fprintf(cgiOut, "<td>%s</td>\n", Title);
		fprintf(cgiOut, "<td>%s</td>\n", Name);
		fprintf(cgiOut, "</tr>\n");
	}
	fprintf(cgiOut, "</table>\n");
	fprintf(cgiOut, "<p><input type=\"submit\" value=\"TwR\">\n");
	fprintf(cgiOut, "<input type=\"reset\" value=\"\">\n");
	fprintf(cgiOut, "<input type=\"button\" value=\"^yï\" OnClick=\"self.location.href='%s'\"></p>\n", GuestURL);
	fprintf(cgiOut, "</center></form>\n");
	fprintf(cgiOut, "<p>@</p>\n");
	fprintf(cgiOut, "<blockquote><hr>\n");
	fprintf(cgiOut, "<form action=\"%s\" method=\"POST\">\n", CGIFile);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"CfgPath\" value=\"%s\">", INIPath);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"WhatToDo\" value=\"display\">\n");
	fprintf(cgiOut, "<input type=\"hidden\" name=\"AdmPage\" value=\"%s\">\n", AdmPage);
	fprintf(cgiOut, "<input type=\"hidden\" name=\"Password\" value=\"%s\">\n", Password);
	fprintf(cgiOut, "<h2>L</h2>\n");
	fprintf(cgiOut, "<blockquote>\n");
	fprintf(cgiOut, "<p>пJsG\n");
	fprintf(cgiOut, "<input type=\"text\" size=\"5\" maxlength=\"5\" name=\"DelPage\">\n");
	fprintf(cgiOut, "<input type=\"submit\" value=\"eX\"></p>\n");
	fprintf(cgiOut, "<p><font color=\"#FF8040\" size=\"2\">\n");
	fprintf(cgiOut, " eXYiC</font></p>\n");
	fprintf(cgiOut, "</blockquote>\n");
	fprintf(cgiOut, "</form>\n");
	fprintf(cgiOut, "</blockquote>\n");
	fprintf(cgiOut, "</body>\n");
	fprintf(cgiOut, "</html>\n");

	fclose(fp);
	return 0;

}
/*========================================================*/
int WriteMsg() {
	int rReplyPage, rReplyNo, Flag;
	FILE *guestadd, *msg;
	char buf[MAX], buf1[MAX];
	char *tmpchar;
	

	/*} guestadd.htm HŪ*/
	if ( (guestadd = fopen( AddPath, "r")) == NULL) {
      sprintf(buf,"Lk}Ҽgsyɮ!! S %s",AddPath);
      output_error(buf, TRUE);
      return(1);
	}

	rReplyNo=cgiFormStringNoNewlines("ReplyNo", ReplyNo, sizeof(ReplyNo));

	sprintf(username,"");
    sprintf(title,"");
	content = NULL;
    
	/*O^峹*/
	if (strcmp(ReplyNo, "") != 0) {
		/*Ū*/
        rReplyPage=cgiFormStringNoNewlines("ReplyPage", ReplyPage, sizeof(ReplyPage));
		/*}Ҹӭ*/
		if ( strcmp(ReplyPage, "") != 0) {
			tmpchar = (char *) malloc(strlen(GuestFile)+1);
		    strcpy(tmpchar,GuestFile);
		    sprintf(buf,"%s.", ReplyPage);
		    tmpchar = SearchReplace(tmpchar, ".", buf);
		    sprintf(buf1,"%s%s", WorkDir, tmpchar);
			free(tmpchar);
		}
		else {
			sprintf(buf1,"%s%s", WorkDir, GuestFile);
		}
		if ( (msg = fopen( buf1, "r")) == NULL) {
			sprintf(buf,"^yɵLk}ɮץHŪe!! S %s",buf1);
			output_error(buf, TRUE);
			return(1);
		}

		/*MӽgT*/
		Flag = FALSE;
		sprintf(buf1,"<A NAME=\"%s\"></A>\n",ReplyNo);
		while ( fgets(buf,MAX,msg)!=NULL ) {
			if (strcmp(buf,buf1)==0) {
				Flag=TRUE;
				break;
			}
		}

		/*T*/
		if (Flag==TRUE) {

		    while ( fgets(buf,MAX,msg)!=NULL ) {
				/*@̦W*/
				if (strcmp(buf, "<!--NAME-->\n")==0) {
					fgets(buf,MAX,msg);
			        tmpchar = (char *) malloc(strlen(buf)+1);
			        strcpy(tmpchar, buf);
			        tmpchar = SearchReplace(tmpchar,"\n","");
			        sprintf(username,"%s",tmpchar);
			        free(tmpchar);
				}

                /*D*/
				else if (strcmp(buf,"<!--TITLE-->\n")==0) {
					fgets(buf,MAX,msg);
			        tmpchar = (char *) malloc(strlen(buf)+1);
			        strcpy(tmpchar, buf);
			        tmpchar = SearchReplace(tmpchar,"\n","");
		            tmpchar = SearchReplace(tmpchar,ReplyMsg,"");
			        sprintf(title,"%s%s", ReplyMsg, tmpchar);
			        free(tmpchar);
				}

			    /*峹e*/
				else if (strcmp(buf,"<!--CONTENT-->\n")==0) {
			        /*Ū峹e*/
					content=NULL;
		            while ( fgets(buf,MAX,msg)!=NULL ) {
						if (strcmp(buf,"<!--CONTENTOVER-->\n")!=0) {
							if ( strcmp(buf,"<BR>\n") == 0)
								continue;
							content = stradd(content, buf);
						}
						else break;
					}
					/*<BR>\n\n*/
			        if (allowHTML == FALSE)
						content = SearchReplace(content,"<BR>\n","\n>");
			        else {
						content = SearchReplace(content,"<BR>\n","\n| ");
				        content = SearchReplace(content,"<font color=#804000><span style=\"font-size: 9pt\">","");
				        content = SearchReplace(content,"</span></font>","");
					}
				}
				else if (strcmp(buf, "<!--OVER-->\n")==0)
					break;
			}
		}
		/*䤣쨺g峹*/
		else {
			sprintf(buf,"䤣zQn^峹!!\nCan't find the article you want to reply!!");
			output_error(buf, FALSE);
            return(1);
		}
		fclose(msg);
	}

	/*}lإ߷sgsy*/

	/*D*/
	Flag=FALSE;
	while ( fgets(buf,MAX,guestadd)!=NULL ) {
		if (strcmp(buf,"<!--TITLE-->\n")==0) {
			Flag=TRUE;
			break;
		}
		fprintf(cgiOut, "%s",buf);
	}
	if (Flag==FALSE) {
		sprintf(buf,"b %s 䤣W@ &lt;!--TITLE--&gt;", AddPath);
        output_error(buf, TRUE);
        return(1);
	}
    /*gJD*/
	fprintf(cgiOut, "<!--TITLE-->\n");
	sprintf(buf,"<INPUT SIZE=45 MAXLENGTH=100 NAME=\"title\" VALUE=\"%s\">\n",title);
	fprintf(cgiOut, "%s",buf);
    fgets(buf,MAX,guestadd);
    
	/*䤺e*/
	Flag=FALSE;
	while ( fgets(buf,MAX,guestadd)!=NULL ) {
		if (strcmp(buf,"<!--CONTENT-->\n")==0) {
			Flag=TRUE;
			break;
		}
		fprintf(cgiOut, "%s",buf);
	}
	if (Flag==FALSE) {
		sprintf(buf,"b %s 䤣W@ &lt;!--CONTENT--&gt;", AddPath);
        output_error(buf, TRUE);
        return(1);
	}
    /*gJe*/
	fprintf(cgiOut, "<!--CONTENT-->\n");
	fgets(buf,MAX,guestadd);
	fprintf(cgiOut, "%s",buf);

	
    if (content == NULL) {
        /*򤺮eg*/
	}
	/*O_e\HTML*/
	else if (allowHTML == FALSE) {
		fprintf(cgiOut, "==>%s%s\n>",username, wrote);
		fprintf(cgiOut, "%s\n",content);
	}
	else {
		fprintf(cgiOut, "<font color=#804000 size=-1><span style=\"font-size: 9pt\">\n| %s%s\n| ",username, wrote);
		fprintf(cgiOut, "%s</span></font><!--%s-->\n", content,username);
	}

	/* TEXTAREA */
	Flag=FALSE;
	while ( fgets(buf,MAX,guestadd)!=NULL ) {
		if (strcmp(buf,"</TEXTAREA>\n")==0) {
			Flag=TRUE;
			break;
		}
    }
	if (Flag==FALSE) {
		sprintf(buf1,"b %s 䤣W@ &lt;/TEXTAREA&gt;", AddPath);
        output_error(buf1, TRUE);
        return(1);
	}
	fprintf(cgiOut, "</TEXTAREA>\n");

	/*ѤU*/
	while ( fgets(buf,MAX,guestadd) != NULL ) {
		fprintf(cgiOut, "%s",buf);
	}

    fclose(guestadd);
    return(0);

}
/*========================================================*/
int NewMessage() {
	int needed;
    int rName, rEmail, rhp, rTitle, rContent, rface, rsex, rimportant, rICQ, rText1, rText2;
	FILE* fp;
	char buf[MAX];

	rName=cgiFormStringNoNewlines("username", username, sizeof(username));
	rEmail=cgiFormStringNoNewlines("email", email, sizeof(email));
	rhp=cgiFormStringNoNewlines("hpurl", hpurl, sizeof(hpurl));
    rICQ=cgiFormStringNoNewlines("ICQ", ICQ, sizeof(ICQ));
	rface=cgiFormStringNoNewlines("face", face, sizeof(face));
	rsex=cgiFormStringNoNewlines("sex", sex, sizeof(sex));
	rTitle=cgiFormStringNoNewlines("title", title, sizeof(title));
	rimportant=cgiFormStringNoNewlines("important", important, sizeof(important));
	rText1=cgiFormStringNoNewlines("Text1", Text1, sizeof(Text1));
	rText2=cgiFormStringNoNewlines("Text2", Text2, sizeof(Text2));
	rContent=cgiFormStringSpaceNeeded("content", &needed);


   /*e*/
	content=(char*) malloc(needed);
	cgiFormString("content", content, needed);

   /*ˬdO_e\ HTML Tag*/
	if (allowHTML == FALSE) {
	  if ((strchr(content, '<') != NULL)
	   || (strchr(username, '<') != NULL)
	   || (strchr(email, '<') != NULL)
	   || (strchr(hpurl, '<') != NULL)
	   || (strchr(title, '<') != NULL) ){
            sprintf(buf,"藍_AdïϥHTMLе'<'ŸAЦ^W@sgeC<BR>\nSorry, we are not allow HTML tag or the character '<'. Please go back and rewrite.");
            output_error(buf, -1);
            return(1);
	  }
	}
	content = SearchReplace(content,"\n","<BR>\n"); /*h\n<BR>*/
    


    /*ŪDatɡAˬddg*/
	if ( (fp = fopen( DatPath, "r")) == NULL) {
      sprintf(buf,"Lk}ҬyïO!! S %s",DatPath);
      output_error(buf, TRUE);
      return(1);
	}
	fgets(buf,MAX,fp);
	pageno = atoi(buf);
	fgets(buf,MAX,fp);
	msgno = atoi(buf);
	fgets(buf,MAX,fp);
	IndexNo = atoi(buf);
	fclose(fp);
	
	if (msgno >= MsgMaxNo) {
	  pageno++;
	  ChagePage();
	  msgno=0;
	}


   /*gJɮ*/
	IndexNo++;
	WriteToFile();
	WriteToIndex(IndexNo);
	msgno++;

   /*gJDat*/
	if ( (fp = fopen( DatPath, "w")) == NULL) {
	  sprintf(buf,"LkgJyïO!! S %s",DatPath);
      output_error(buf, TRUE);
      return(1);
	}
	fprintf(fp,"%d\n%d\n%d",pageno,msgno,IndexNo); /*datɤTӼƦr*/
    fclose(fp);                                    /*ơBثeTƥءBT޽s*/

   /*eXT*/
    fprintf(cgiOut, "<HTML>\n");
    fprintf(cgiOut, "<HEAD>\n");
    fprintf(cgiOut, "<TITLE>Thanks!!</TITLE>\n");
    fprintf(cgiOut, "<SCRIPT>\n<!--\nfunction LoadGuest()\n");
    fprintf(cgiOut, "  {\n    alert(\"%s\")\n", successmsg);
    fprintf(cgiOut, "    self.location.href = \"%s\"\n",GuestURL);
    fprintf(cgiOut, "  }\n//-->\n</SCRIPT>\n");
    fprintf(cgiOut, "</HEAD>\n");
    fprintf(cgiOut, "<BODY BGCOLOR=#FFFFFF onLoad=\"LoadGuest()\">\n");
    fprintf(cgiOut, "</BODY>\n");
    fprintf(cgiOut, "</HTML>\n");

	free(content);
	return(0);

}

/*========================================================*/
void ChagePage() {
	FILE *source, *temp;
	int flag=0;
	char buf[MAX], *tmpchar, NewPageName[MID], NewFile[MID];

	/*ͷsɮ׸|*/
	tmpchar = (char *) malloc(strlen(GuestFile)+1);
    strcpy(tmpchar,GuestFile);
    sprintf(buf,"%d.", pageno);
	tmpchar = SearchReplace(tmpchar, ".", buf);
	strcpy(NewPageName, tmpchar);
	free(tmpchar);
	sprintf(NewFile,"%s%s", WorkDir, NewPageName);

	/* guest.htm ƻss*/
	flag = CopyFile(NewFile,HtmlPath);
	if (flag==1)
		exit(1);


	/* ReplyPage*/
	if ( (source = fopen( NewFile, "r")) == NULL) {
        sprintf(buf,"ܧޮɵLk}ɮ!! S %s", NewFile);
        output_error(buf, TRUE);
        exit(1);
	}
	if ( (temp = fopen( TempPath, "w")) == NULL) {
        sprintf(buf,"ܧޮɵLk}ҼȦsɮ!! S %s",TempPath);
        output_error(buf, TRUE);
        exit(1);
	}

	/*M <!--PAGE-->*/
	flag = 0;
    while ( fgets(buf,MAX,source) != NULL ) {
        if ( strcmp(buf,"<!--PAGE-->\n") == 0) {
   	        flag=1;
	        break;
		}
        fputs(buf,temp);
	}
	/*S<!--PAGE-->*/
    if (flag==0) {
        sprintf(buf,"ܧޮɡA%s ɮפS &lt;!--PAGE--&gt; Wo@",buf);
        output_error(buf, TRUE);
        fclose(source);
        fclose(temp);
        exit(1);
	}

    fprintf(temp,"<!--PAGE-->\n");
	fprintf(temp,"<input type=\"hidden\" value=\"%d\" name=\"ReplyPage\">\n", pageno);
	fgets(buf,MAX,source);

	/*ѤU*/
    while ( fgets(buf,MAX,source) != NULL )
        fputs(buf,temp);


    fclose(source);
    fclose(temp);

    /*temp^h*/
	flag = CopyFile(NewFile,TempPath);
	if (flag == 1)
		exit(1);

	/*Indexɮ*/
	if ( (source = fopen( IndexPath, "r")) == NULL) {
        sprintf(buf,"ܧޮɵLk}үɮ!! S %s",IndexPath);
        output_error(buf, TRUE);
        exit(1);
	}
    if ( (temp = fopen( TempPath, "w")) == NULL) {
        sprintf(buf,"ܧޮɵLk}ҼȦsɮ!! S %s",TempPath);
        output_error(buf, TRUE);
        exit(1);
	}
    /*}l*/
	flag = 0;
    while ( fgets(buf,MAX,source) != NULL ) {
        if ( strcmp(buf,"<!--START-->\n") == 0) {
   	        flag=1;
	        break;
		}
        fputs(buf,temp);
	    strcpy(buf,"");
	}
	/*S<!--START-->*/
    if (flag==0) {
        sprintf(buf,"ܧޮɡA%s ɮפS &lt;!--START--&gt; Wo@",IndexPath);
        output_error(buf, TRUE);
        fclose(source);
        fclose(temp);
        exit(1);
	}

    fprintf(temp,"<!--START-->\n");
    /*}ljMme*/
	while ( fgets(buf,MAX,source) != NULL ) {
		if (strstr(buf, GuestFile) != NULL) {
            tmpchar = (char *) malloc(strlen(buf)+1);
			strcpy(tmpchar,buf);
			tmpchar = SearchReplace(tmpchar, GuestFile, NewPageName);
			strcpy(buf,tmpchar);
			free(tmpchar);
		}
		fputs(buf,temp);
	}
    fclose(source);
    fclose(temp);

	/*temp^h*/
	flag = CopyFile(IndexPath,TempPath);
	if (flag == 1)
		exit(1);

	
	/*إ߷s guest */
	if ( (source = fopen( HtmlPath, "r")) == NULL) {
        sprintf(buf,"ɵLk}ɮ!! S %s", HtmlPath);
        output_error(buf, TRUE);
        exit(1);
	}
	if ( (temp = fopen( TempPath, "w")) == NULL) {
        sprintf(buf,"ɵLk}ҼȦsɮ!! S %s",TempPath);
        output_error(buf, TRUE);
        exit(1);
	}

	/*M <!--PAGE-->*/
	flag = 0;
    while ( fgets(buf,MAX,source) != NULL ) {
        if ( strcmp(buf,"<!--PAGE-->\n") == 0) {
   	        flag=1;
	        break;
		}
        fputs(buf,temp);
	}
	/*S<!--PAGE-->*/
    if (flag==0) {
        sprintf(buf,"ɡA%s ɮפS &lt;!--PAGE--&gt; Wo@",buf);
        output_error(buf, TRUE);
        fclose(source);
        fclose(temp);
        exit(1);
	}

    fprintf(temp,"<!--PAGE-->\n");
	fprintf(temp,"<input type=\"hidden\" value=\"\" name=\"ReplyPage\">\n");
	fgets(buf,MAX,source);

	/* <!--START-->*/
	flag = 0;
    while ( fgets(buf,MAX,source) != NULL ) {
        if ( strcmp(buf,"<!--START-->\n") == 0) {
   	        flag=1;
	        break;
		}
        fputs(buf,temp);
	}
	/*S<!--START-->*/
    if (flag==0) {
        sprintf(buf,"ɡAɮ %s S &lt;!--START--&gt; o@", HtmlPath);
        output_error(buf, TRUE);
        fclose(source);
        fclose(temp);
        exit(1);
	}

    fprintf(temp,"<!--START-->\n");
    
	/*䵲*/
	flag = 0;
    while ( fgets(buf,MAX,source) != NULL ) {
        if ( strcmp(buf,"<!--END-->\n") == 0) {
   	        flag=1;
	        break;
		}
	}
	/*S<!--END-->*/
    if (flag==0) {
        sprintf(buf,"ɡAɮ %s S &lt;!--END--&gt; o@", HtmlPath);
        output_error(buf, TRUE);
        fclose(source);
        fclose(temp);
        exit(1);
	}
    /*U@Link*/
	fprintf(temp,"<CENTER><a href=\"%s\"><img src=\"%snextpage.gif\" alt=\"%s\" border=0></a></CENTER>\n", NewPageName, PicDir, NextPageMsg);
	fprintf(temp,"<!--END-->\n");
    
	/*ѤU*/
    while ( fgets(buf,MAX,source) != NULL )
        fputs(buf,temp);


    fclose(source);
    fclose(temp);

    /*temp^h*/
	flag = CopyFile(HtmlPath,TempPath);
	if (flag == 1)
		exit(1);

	return;
}
/*========================================================*/
void WriteToFile()
{
  FILE *out, *temp, *fp;
  char buf[MAX];
  char *str, *str1;
  int flag=0;

  if ( (out = fopen( HtmlPath, "r")) == NULL)
  {
    sprintf(buf,"gJsTɡALk}Ҭyïɮ %s",HtmlPath);
    output_error(buf, TRUE);
    exit(1);
  }
  if ( (temp = fopen( TempPath, "w")) == NULL)
  {
    sprintf(buf,"gJsTɡALk}ҼȦsɮ %s",TempPath);
    output_error(buf, TRUE);
    exit(1);
  }

/*}Y*/
  while ( fgets(buf,MAX,out) != NULL )
  {
    if ( strcmp(buf,"<!--START-->\n") == 0)
    {
	 flag=1;
	 break;
    }
    fputs(buf,temp);
  }

/*S<!--START-->*/
  if (flag==0)
  {
    sprintf(buf,"gJsTɡA%s ɮפS &lt;!--START--&gt; o@",HtmlPath);
    output_error(buf, FALSE);
    fclose(temp);
    fclose(out);
    exit(1);
  }

/*gJsT*/
  fprintf(temp,"<!--START-->\n");
  fprintf(temp,"\n<A NAME=\"%d\"></A>\n", IndexNo); /*Target*/
  fprintf(temp,"<!--========================================================-->\n");

  /*dɮ*/
  if ( (strcmp(TempletPath,"") !=0 ) && ( (fp = fopen( TempletPath, "r")) != NULL) ) {
	  str = NULL;
	  /*Ūdɮפe*/
	  while ( fgets(buf,MAX,fp)!=NULL )
		  str = stradd(str,buf);

	  fclose(fp);

	  /*mUe*/
	  /*Wr*/
	  sprintf(buf,"\n<!--NAME-->\n%s\n", username);
	  str = SearchReplace(str, "%NAME%", buf);
	  /*D*/
	  sprintf(buf,"\n<!--TITLE-->\n%s\n", title);
	  str = SearchReplace(str, "%TITLE%", buf);
	  /*ɶ*/
	  str = SearchReplace(str, "%TIME%", PrintTime(Language));
	  /*^峹s*/
	  sprintf(buf,"\n<input type=\"radio\" value=\"%d\" name=\"ReplyNo\">", IndexNo);
      str = SearchReplace(str, "%REPLY%", buf);
      /*Email*/
	  if ( strcmp(email, "") > 0) {
		  sprintf(buf,"\n<A HREF=\"mailto:%s\"><IMG SRC=\"%smailto.gif\" BORDER=0 HSPACE=5></A>",email, PicDir);
		  str = SearchReplace(str, "%EMAILPIC%", buf);
		  str = SearchReplace(str, "%EMAIL%", email);
	  }
	  else {
		  str = SearchReplace(str, "%EMAILPIC%", "");
		  str = SearchReplace(str, "%EMAIL%", "");
	  }
	  /*homepage*/
	  if ( strcmp(hpurl, "http://") > 0) {
		  sprintf(buf,"\n<A HREF=\"%s\"><IMG SRC=\"%shpurl.gif\" BORDER=0 HSPACE=5></A>",hpurl, PicDir);
		  str = SearchReplace(str, "%URLPIC%", buf);
		  str = SearchReplace(str, "%URL%", hpurl);
	  }
	  else {
		  str = SearchReplace(str, "%URLPIC%", "");
		  str = SearchReplace(str, "%URL%", "");
	  }
	  /*ICQ*/
	  if ( strcmp(ICQ, "") > 0) {
		  sprintf(buf,"\n<IMG SRC=\"%sicq.gif\" BORDER=0 HSPACE=3>%s", PicDir, ICQ);
		  str = SearchReplace(str, "%ICQ%", buf);
	  }
	  else
		  str = SearchReplace(str, "%ICQ%", "");
	  /*Wm*/
	  if ( strcmp(cgiRemoteHost, "") > 0)
		  str = SearchReplace(str, "%FROM%", cgiRemoteHost);
	  else
		  str = SearchReplace(str, "%FROM%", cgiRemoteAddr);
	  /*Ϯ*/
	  if ( face[0] && sex[0]) {
		  sprintf(buf,"\n<IMG SRC=\"%s%s%s\" HSPACE=3>", PicDir, sex, face);
		  str = SearchReplace(str, "%FACEPIC%", buf);
	  }
	  else
		  str = SearchReplace(str, "%FACEPIC%", "");
	  /*Od1*/
	  if ( strcmp(Text1, "") > 0) {
		  str = SearchReplace(str, "%TEXT1%", Text1);
	  }
	  else
		  str = SearchReplace(str, "%TEXT1%", "");
	  /*Od2*/
	  if ( strcmp(Text2, "") > 0) {
		  str = SearchReplace(str, "%TEXT2%", Text2);
	  }
	  else
		  str = SearchReplace(str, "%TEXT2%", "");
	  /**/
	  str1 = (char *) malloc(strlen(content)+MID);
	  sprintf(str1,"\n<!--CONTENT-->\n%s\n<!--CONTENTOVER-->\n", content);
	  str = SearchReplace(str, "%CONTENT%", str1);
	  free(str1);

	  /*gJɮ*/
	  fprintf(temp,"%s", str);
	  free(str);

  }
  /*SdɮסAΤw榡*/
  else {
	  fprintf(temp,"<CENTER><TABLE BORDER=0 WIDTH=\"90%c\" ><TR>\n",'%');

      /*n*/
      if (!important[0])
		  sprintf(important,"#FFFFFF"); /*SnʡAզI*/
	  fprintf(temp,"<TD BGCOLOR=\"%s\" WIDTH=\"1%c\" rowspan=\"2\">&nbsp;</TD>\n", important, '%');

      fprintf(temp,"<TD>");
      /*ˬdO_Ϥ*/
      if ( face[0] && sex[0]) {
		  sprintf(buf,"%s%s", sex, face);
          fprintf(temp,"<IMG SRC=\"%s%s\" ALIGN=LEFT HSPACE=3>", PicDir, buf);
	  }
      /*Wr*/
      fprintf(temp,"<input type=\"radio\" value=\"%d\" name=\"ReplyNo\"><FONT COLOR=\"#0080FF\">\n<!--NAME-->\n%s\n</FONT>",IndexNo, username);
  
      /*ˬdO_ email*/
      if ( strcmp(email, "") > 0)
		  fprintf(temp, "\n<A HREF=\"mailto:%s\"><IMG SRC=\"%smailto.gif\" BORDER=0 HSPACE=5></A>",email, PicDir);
      /*ˬdO_ homepage*/
      if ( strcmp(hpurl, "http://") > 0)
		  fprintf(temp, "\n<A HREF=\"%s\"><IMG SRC=\"%shpurl.gif\" BORDER=0 HSPACE=5></A>",hpurl, PicDir);
      /*ˬdO_ ICQ*/
      if ( strcmp(ICQ, "") > 0)
		  fprintf(temp, "\n<IMG SRC=\"%sicq.gif\" BORDER=0 HSPACE=3><FONT FACE=\"Arial,Helvetica\" SIZE=-1><span style=\"font-size: 9pt\">%s</span></FONT>",PicDir, ICQ);
  
      /*DASϤPmk*/
	  if ( face[0] && sex[0])
		  fprintf(temp, "\n<P><B>\n<!--TITLE-->\n%s\n</B>", title);
      else
		  fprintf(temp, "\n<BR><B>\n<!--TITLE-->\n%s\n</B>", title);

      fprintf(temp, "</TD>\n");
      fprintf(temp, "<TD ALIGN=RIGHT VALIGN=TOP NOWARP>");
      /*ɶ*/
      fprintf(temp, "<FONT COLOR=\"#C0C0C0\" FACE=\"Arial,Helvetica\" SIZE=-1><span style=\"font-size: 9pt\">");
      /*Wm*/
	  if ( strcmp(cgiRemoteHost,"") ==0 )
		  fprintf(temp, "%s",cgiRemoteAddr);
	  else
		  fprintf(temp, "%s",cgiRemoteHost);
	/*ɶ*/
      fprintf(temp,"<BR>%s",PrintTime(Language));
	  fprintf(temp, "</span></FONT>");
      fprintf(temp, "</TD>");
      fprintf(temp, "</TR>\n");
      fprintf(temp, "<TR><TD colspan=\"2\">");
      /**/
      fprintf(temp, "<P>\n<!--CONTENT-->\n%s\n<!--CONTENTOVER-->\n", content);
      fprintf(temp, "</P></TD>");
      fprintf(temp,"</TR></TABLE><HR WIDTH=90%c></CENTER>",'%');
  }
  /**/
  fprintf(temp,"\n<!--OVER-->\n");

  /*ѤU*/
  while ( fgets(buf,MAX,out) != NULL ) {
	  fputs(buf,temp);
  }
  fclose (out);
  fclose (temp);

  /*temp^h*/
  flag = CopyFile(HtmlPath,TempPath);
  if (flag == 1)
	  exit(1);

  return;
}

/*========================================================*/
void WriteToIndex(int no)
{
  FILE *out, *temp;
  char string1[MAX];
  char buf[MAX];
  int flag=0;
  /*ɶ*/
  struct tm *curtime;
  time_t bintime;
  time(&bintime);
  curtime = localtime(&bintime);

  /*}*/
  if ( (out = fopen( IndexPath, "r")) == NULL)
  {
    sprintf(buf,"gJsޮɡALk}ɮ %s",IndexPath);
    output_error(buf, TRUE);
    exit(1);
  }
  if ( (temp = fopen( TempPath, "w")) == NULL)
  {
    sprintf(buf,"gJsޮɡALk}ҼȦsɮ %s",TempPath);
    output_error(buf, TRUE);
    exit(1);
  }

  strcpy(string1,"");
/*}Y*/
  while ( fgets(string1,MAX,out) != NULL )
  {
    if ( strcmp(string1,"<!--START-->\n") == 0)
    {
	 flag=1;
	 break;
    }
    fputs(string1,temp);
  }

/*S<!--START-->*/
  if (flag==0)
  {
    sprintf(buf,"gJsޮɡA%s ɮפS &lt;!--START--&gt; o@",IndexPath);
    output_error(buf, FALSE);
    fclose(temp);
    fclose(out);
    exit(1);
  }

/*gJsT*/
  /*D*/
  fprintf(temp,"<!--START-->\n");
  fprintf(temp,"<!--%d-->\n",no);
  if ((no % 5) == 0)
	  fprintf(temp,"<TR BGCOLOR=\"#FFFFCC\"><TD>");
  else
	  fprintf(temp,"<TR><TD>");
  fprintf(temp,"<A HREF=\"%s#%d\">", GuestFile, no);
  /*Ϥ*/
  if ( strcmp(important,abg1) == 0 )
	  fprintf(temp,"<IMG SRC=\"%smsglist1.gif\" HSPACE=3 BORDER=0></A>", PicDir);
  else if ( strcmp(important,abg2) == 0)
	  fprintf(temp,"<IMG SRC=\"%smsglist2.gif\" HSPACE=3 BORDER=0></A>", PicDir);
  else
	  fprintf(temp,"<IMG SRC=\"%smsglist.gif\" HSPACE=3 BORDER=0></A>", PicDir);
  /*D*/
  fprintf(temp,"%s</TD>\n", title);
 
  /*ɶ*/
  fprintf(temp,"<TD>%d/%d</TD>", curtime->tm_mon+1, curtime->tm_mday);
  /*@*/
  fprintf(temp,"<TD>%s</TD>\n", username);
  fprintf(temp,"</TR>\n");

/*ѤU*/
  while ( fgets(string1,MAX,out) != NULL )
  {
    fputs(string1,temp);
  }
  fclose (out);
  fclose (temp);

/*temp^h*/
  	flag = CopyFile(IndexPath,TempPath);
	if (flag == 1)
		exit(1);
  return;
}

/*========================================================*/
void output_error(char* error, int serious)
{
	fprintf(cgiOut, "<HTML>\n");
	fprintf(cgiOut, "<HEAD>\n");
	fprintf(cgiOut, "<TITLE>Error!!</TITLE>\n");
	fprintf(cgiOut, "</HEAD>\n");
	fprintf(cgiOut, "<BODY bgcolor=#FFFFFF>\n");
	fprintf(cgiOut, "<H2>oͿ~!! Error!!</H2>\n");
	fprintf(cgiOut, "<b><FONT COLOR=\"red\">%s</FONT></b>\n<p>\n", error);

/*yLY~*/
    if (serious >= FALSE) {
	    fprintf(cgiOut, "бHe-mail");
	    if (!webmaster[0]) {
		    fprintf(cgiOut, "oӭ޲z");
		} else {
		    fprintf(cgiOut, " <a href=\"mailto:%s\">%s</a> ", webmaster, webmaster);
		}
	    fprintf(cgiOut, "AiDLoӿ~TA§A!!<BR>\n");
	    /*^T*/
	    fprintf(cgiOut, "Please send e-mail to ");
	    if (!webmaster[0]) {
		    fprintf(cgiOut, "this pagemaster");
		} else {
		    fprintf(cgiOut, " <a href=\"mailto:%s\">%s</a> ", webmaster, webmaster);
		}
	    fprintf(cgiOut, ", tell him this error message. Thank you!!<P>\n");
	    if (!HomeURL[0]) {
		    fprintf(cgiOut, "\n");
		} else {
		    fprintf(cgiOut, " <BR>[ <A HREF=\"%s\">^쭺</A> ] [ <A HREF=\"%s\">Back to Homepage</A> ]\n", HomeURL, HomeURL);
		}
	}
/*pGOY~ANܧhT*/
	if (serious == TRUE) {
		fprintf(cgiOut, "\n<blockquote>\n<HR>\n");
		fprintf(cgiOut, "<p>pGANOoӺ޲z̡AAӡG<ul>\n");
		fprintf(cgiOut, "<li><p align=\"left\">ˬd|ҫɮ׬O_sbC</p></li>\n");
		fprintf(cgiOut, "<li><p align=\"left\">O_٨SקɮתϥvAҥH~Lk}ҡBgJC</p></li>\n");
		fprintf(cgiOut, "<li><p align=\"left\">&lt;!--START--&gt; M &lt;!--END--&gt;\n");
		fprintf(cgiOut, "ΨLrO_OWAP@eSLrαrC</p></li>\n");
		fprintf(cgiOut, "<li><p align=\"left\">Բ[ݬyï{\n");
		fprintf(cgiOut, "<a href=\"http://homepage.ohya.com.tw/hp/gb_faq.htm\"><font face=\"Arial Black\">FAQ</font></a>\n");
		fprintf(cgiOut, "Mw˻C</p></li>\n");
		fprintf(cgiOut, "</UL>\n");
		fprintf(cgiOut, "<p>@</p>\n");
		fprintf(cgiOut, "pG٬ODzLkѨMA<a href=\"mailto:gaspy@ksts.seed.net.tw\">gHp</a>A\n");
		fprintf(cgiOut, "åBbHeaUTG<ul>\n");
        fprintf(cgiOut, "<li><p align=\"left\">oӭ̤Wܪ~TC</p></li>\n");
		fprintf(cgiOut, "<li><p align=\"left\">zwˬyï}C</p></li>\n");
		fprintf(cgiOut, "</UL>\n");
		fprintf(cgiOut, "</blockquote>\n");
	}
	fprintf(cgiOut, "</BODY>");
	fprintf(cgiOut, "</HTML>");
}
/*========================================================*/
void getCFGString(char* section, FILE* fp, char* result)
{
	char buf[256];
	int done = FALSE;

	/*Go to beginning of file*/
	fseek(fp, 0L, SEEK_SET);
	strcpy(result, "");

	while (fgets(buf, 256, fp) && !done) {
		if (buf[strlen(buf)-1] == '\n')
			buf[strlen(buf)-1]='\0';
		if (!strcmp(buf, section) ) {
		/*Found the section*/
			while(fgets(buf, 256, fp)) {
				if (buf[strlen(buf)-1] == '\n')
					buf[strlen(buf)-1]='\0';
				/*Are we in the next section now?*/
				if (buf[0]=='[') {
					return;
				}
				if (strlen(buf)>0) {
					strcpy(result, buf);
					done = TRUE;
					break;
				}
			}
		}
	}

}

/*========================================================*/
int read_configuration()
{
	char buf[MAX];
	FILE* fp;

   fp = fopen(CfgPath, "r");

	if (fp == NULL) {
		sprintf(buf, "Lk}ҨtθT %s", CfgPath);
		output_error(buf, TRUE);
		exit(1);
	}

/*Ūiniɤ*/
	getCFGString("[Bookmaster_email]",fp, webmaster);
	getCFGString("[Guest_Book_URL]",fp, GuestURL);
	getCFGString("[Homepage_URL]",fp, HomeURL);
	getCFGString("[Guest_Book_Work_Dir]",fp, WorkDir);
	getCFGString("[Guest_Pictures_Dir]",fp, buf);
	if (strcmp(buf, "NO")==0)
		strcpy(PicDir,"");
	else
		strcpy(PicDir,"guestpic/");

	getCFGString("[CGI_Filename]",fp, CGIFile);
	getCFGString("[Guest_Book_Filename]",fp, GuestFile);
	sprintf(HtmlPath,"%s%s", WorkDir, GuestFile);
	getCFGString("[Guest_Add_Filename]",fp, buf);
	sprintf(AddPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_Index_Filename]",fp, buf);
	sprintf(IndexPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_Dat_Filename]",fp, buf);
	sprintf(DatPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_Log_Filename]",fp, buf);
	sprintf(LogPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_INI_Filename]",fp, buf);
    sprintf(INIPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_Temp_Filename]",fp, buf);
	sprintf(TempPath,"%s%s", WorkDir, buf);
	getCFGString("[Guest_Templet_Filename]",fp, buf);
	if ( strcmp(buf, "") != 0 )
		sprintf(TempletPath,"%s%s", WorkDir, buf);
	else
		strcpy(TempletPath, "");
	getCFGString("[Success_message]",fp, successmsg);
	getCFGString("[Next_Page_message]",fp, NextPageMsg);
	getCFGString("[MAX_Message_Number]",fp, buf);
	MsgMaxNo = atoi(buf);
    getCFGString("[Wrote_message]",fp, wrote);
	getCFGString("[Reply_message]",fp, ReplyMsg);
	getCFGString("[Allow_HTML]",fp, buf);
	if (strcmp(buf,"NO") == 0)
		allowHTML = FALSE;
	else allowHTML = TRUE;

	fclose(fp);

	return TRUE;
}



